'Written by Adrian Jensen
'Predictive Engineering 2012
'Predictive Engineering Assumes No Responsibility For Results Obtained From API
'Written for FEMAP 10.3.1
'This API will create text boxes to label the ID number of selected elements and nodes.
'Element ID numbers are displayed within parentheses.

Sub Main
'Attach To the model in a femap session that is already running
    Dim App As femap.model
    Set App = feFemap()

'Create text object
	Dim feText As Object
	Set feText = App.feText

'Create a set for text entities
	Dim feTextSET As Object
	Set feTextSET = App.feSet

'Create a node object
	Dim feNode As Object
	Set feNode = App.feNode

'Create a set for nodes
    Dim feNodeSET As Object
    Set feNodeSET = App.feSet

'Create node variables
	Dim feNodeID As Long
	Dim feNodeIDa(20) As Long
	Dim feNodeIDv As Variant
	feNodeIDv = feNodeIDa

'Create element object
	Dim feElem As Object
	Set feElem = App.feElem

'Create a set for elements
    Dim feElemSET As Object
    Set feElemSET = App.feSet

	Dim feElemID As Long
	Dim feElemX As Double
	Dim feElemY As Double
	Dim feElemZ As Double


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Provide option to delete text entities
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Dim delPrevLABELS As Long
	delPrevLABELS = App.feAppMessageBox(3,"Do you want to delete all text entities?")

	If delPrevLABELS = FE_CANCEL Then
		GoTo QUIT

	ElseIf delPrevLABELS = FE_OK Then
		While feText.Next
			feTextSET.Add(feText.ID)
		Wend

		App.feDelete(FT_TEXT,feTextSET.ID)
		App.feViewRegenerate(0)
		App.feAppMessage(3,"All Text Entities Deleted from Model")

	End If

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'ELEMENTS
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Prompt user to select elements for labeling
	feElemSET.Select(8,True,"Select Elements to Label with ID")
	feElemID = feElemSET.First

'Loop through all elements in set
	While feElemID > 0

'Clear the variables
		feElemX =0
		feElemY=0
		feElemZ=0
		For i=0 To 19
			feNodeIDv(i) =0
		Next

		feElem.Get(feElemID)
		feNodeIDv = feElem.vnode

'If LINE element
		If feElem.topology=0 Then
			For i=0 To 1
				feNode.Get(feNodeIDv(i))
				feElemX=feElemX + feNode.x
				feElemY=feElemY + feNode.y
				feElemZ=feElemZ + feNode.z
			Next

			feElemX=feElemX/2
			feElemY=feElemY/2
			feElemZ=feElemZ/2

'If TRI3 or TRI6 element
		ElseIf feElem.topology=2 Or feElem.topology=3 Then
			For i=0 To 2
				feNode.Get(feNodeIDv(i))
				feElemX=feElemX + feNode.x
				feElemY=feElemY + feNode.y
				feElemZ=feElemZ + feNode.z
			Next

			feElemX=feElemX/3
			feElemY=feElemY/3
			feElemZ=feElemZ/3

'If QUAD4 or QUAD8 element
		ElseIf feElem.topology=4 Or feElem.topology=5 Then
			For i=0 To 3
				feNode.Get(feNodeIDv(i))
				feElemX=feElemX + feNode.x
				feElemY=feElemY + feNode.y
				feElemZ=feElemZ + feNode.z
			Next

			feElemX=feElemX/4
			feElemY=feElemY/4
			feElemZ=feElemZ/4

'If TETRA4 or TETRA10 element
		ElseIf feElem.topology=6 Or feElem.topology=10 Then
			For i=0 To 2
				feNode.Get(feNodeIDv(i))
				feElemX=feElemX + feNode.x
				feElemY=feElemY + feNode.y
				feElemZ=feElemZ + feNode.z
			Next
			feNode.Get(feNodeIDv(4))
			feElemX=feElemX + feNode.x
			feElemY=feElemY + feNode.y
			feElemZ=feElemZ + feNode.z

			feElemX=feElemX/4
			feElemY=feElemY/4
			feElemZ=feElemZ/4

'If WEDGE6 or WEDGE15element
		ElseIf feElem.topology=7 Or feElem.topology=11 Then
			For i=0 To 2
				feNode.Get(feNodeIDv(i))
				feElemX=feElemX + feNode.x
				feElemY=feElemY + feNode.y
				feElemZ=feElemZ + feNode.z
			Next
			For i=4 To 6
				feNode.Get(feNodeIDv(i))
				feElemX=feElemX + feNode.x
				feElemY=feElemY + feNode.y
				feElemZ=feElemZ + feNode.z
			Next

			feElemX=feElemX/6
			feElemY=feElemY/6
			feElemZ=feElemZ/6

'If BRICK8 or BRICK20 element
		ElseIf feElem.topology=8 Or feElem.topology=12 Then
			For i=0 To 7
				feNode.Get(feNodeIDv(i))
				feElemX=feElemX + feNode.x
				feElemY=feElemY + feNode.y
				feElemZ=feElemZ + feNode.z
			Next

			feElemX=feElemX/8
			feElemY=feElemY/8
			feElemZ=feElemZ/8

		Else
			App.feAppMessageBox(0,"Element Type for Element " + CStr(feElemID) + " Not Supported")
			GoTo NO_LABEL

		End If

'Set up options for the text entity
		feText.ModelPosition = True
		feText.AllViews = True
		feText.DrawBorder = True
		feText.BorderColor = FCL_BLACK
		feText.BackColor = FCL_WHITE
		feText.color = FCL_BLACK
		feText.layer = 1
		feText.FontNumber = 1
		feText.ID = App.Info_NextID(FT_TEXT)
		feText.TextPosition(0) = feElemX
		feText.TextPosition(1) = feElemY
		feText.TextPosition(2) = feElemZ
		feText.text = "("+CStr(feElem.ID)+")"
		feText.Put(feText.ID)

NO_LABEL:
		feElemID=feElemSET.Next

	Wend

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'NODES
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Prompt user to select elements for labeling
	feNodeSET.Select(7,True,"Select Nodes to Label with ID")
	feNodeID = feNodeSET.First

'Loop through all elements in set
	While feNodeID > 0
		feNode.Get(feNodeID)

'Set up options for the text entity
		feText.ModelPosition = True
		feText.AllViews = True
		feText.DrawBorder = True
		feText.BorderColor = FCL_BLACK
		feText.BackColor = FCL_WHITE
		feText.color = FCL_BLACK
		feText.layer = 1
		feText.FontNumber = 1
		feText.ID = App.Info_NextID(FT_TEXT)
		feText.TextPosition(0) = feNode.x
		feText.TextPosition(1) = feNode.y
		feText.TextPosition(2) = feNode.z
		feText.text = CStr(feNode.ID)
		feText.Put(feText.ID)

		feNodeID=feNodeSET.Next

	Wend
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

QUIT:
App.feViewRegenerate(0)
App.feAppMessage(3,"Program Completed")
End Sub
